<?php
defined('BASEPATH') OR exit('No direct script access allowed');

 
class Propiedad extends CI_Controller{
    function __construct()
    {
        parent::__construct();
        $this->load->model('Propiedad_model');
    } 

    /*
     * Listing of propiedades
     */
    function index($page = FALSE)
    {
        if(!($this->session->userdata('id'))) 
        {
            redirect(base_url()."login");
        };

        $breadcrumb = array(
            "Casetas de Vigilancia" => ""
        );
        $data['breadcrumb'] = $breadcrumb;

        $params['page'] = $page;
        $params['limit'] = 5; 
        $params['offset'] = $page ? (($page - 1) * $params['limit']) : 0;
        
        $config = $this->config->item('pagination');
        $config['base_url'] = site_url('propiedad/page');
        $config['total_rows'] = $this->Propiedad_model->get_all_propiedades_count();
        $config['per_page'] = $params['limit'];
        $config['use_page_numbers'] = TRUE;
        $config['first_url'] = base_url('propiedad');
        $config['attributes'] = array('class' => 'page-link');
        $config['full_tag_open'] = '<ul class="pagination">';
        $config['full_tag_close'] = '</ul>';
        $config['cur_tag_open'] = '<li class="page-item active"><span class="page-link">';
        $config['cur_tag_close'] = '</span></li>';
        $config['num_tag_open'] = '<li class="page-item">';
        $config['num_tag_close'] = '</li>';
        $config['prev_tag_open'] = '<li class="page-item">';
        $config['prev_tag_close'] = '</li>';
        $config['next_tag_open'] = '<li class="page-item">';
        $config['next_tag_close'] = '</li>';
        $config['first_tag_open'] = '<li class="page-item">';
        $config['first_tag_close'] = '</li>';
        $config['last_tag_open'] = '<li class="page-item">';
        $config['last_tag_close'] = '</li>';
        $config['first_link'] = "<<";
        $config['last_link'] = ">>";
        $this->pagination->initialize($config);

        $data['listado'] = TRUE;
        $data['controlador'] = 'propiedad';
        $data['propiedades'] = $this->Propiedad_model->get_all_propiedades($params);
        
        $data['contenido'] = 'propiedad/index';
        $data['titulo'] = 'Propiedades';
        $this->load->view('templates/template_admin', $data);
    }

    /*
     * Adding a new propiedad
     */
    function add()
    {   
        if(!($this->session->userdata('id'))) 
        {
            redirect(base_url()."login");
        };
        $breadcrumb = array(
            "Propiedades" => "./",
            "Agregar" => ""
        );
        $data['breadcrumb'] = $breadcrumb;

        $this->load->library('form_validation');

		$this->form_validation->set_rules('nombre','Nombre','required');
		$this->form_validation->set_rules('numero_exterior','Numero Exterior','required');
		
		if($this->form_validation->run())     
        {   
            $params = array(
				'nombre' => $this->input->post('nombre'),
				'direccion' => $this->input->post('direccion'),
				'telefono' => $this->input->post('telefono'),
				'id_condominio' => $this->session->userdata('condominio'),
				'couta_mantenimiento' => $this->input->post('couta_mantenimiento'),
				'fecha_registro' => date("Y-m-d H:i:s"),
				'fecha_modificacion' => date("Y-m-d H:i:s"),
				'estado' => 1,
				'cuota_mantenimiento' => $this->input->post('cuota_mantenimiento'),
				'calle' => $this->input->post('calle'),
				'numero_exterior' => $this->input->post('numero_exterior'),
				'codigo_postal' => $this->input->post('codigo_postal'),
            );
            
            $propiedad_id = $this->Propiedad_model->add_propiedad($params);
            redirect('propiedad');
        }
        else
        {            
            $data['controlador'] = 'propiedad';
            $data['contenido'] = 'propiedad/add';
            $data['titulo'] = 'Nueva Propiedad';
            $this->load->view('templates/template_admin', $data);
        }
    }  

    /*
     * Editing a propiedad
     */
    function edit($id)
    {   
        if(!($this->session->userdata('id'))) 
        {
            redirect(base_url()."login");
        };
        $breadcrumb = array(
            "Propiedades" => "../",
            "Editar" => ""
        );
        $data['breadcrumb'] = $breadcrumb;

        // check if the propiedad exists before trying to edit it
        $data['propiedad'] = $this->Propiedad_model->get_propiedad($id);
        
        if(isset($data['propiedad']['id']))
        {
            $this->load->library('form_validation');

			$this->form_validation->set_rules('nombre','Nombre','required');
			$this->form_validation->set_rules('numero_exterior','Numero Exterior','required');
		
			if($this->form_validation->run())     
            {   
                $params = array(
					'nombre' => $this->input->post('nombre'),
					'direccion' => $this->input->post('direccion'),
					'telefono' => $this->input->post('telefono'),
					'id_condominio' => $this->input->post('id_condominio'),
					'couta_mantenimiento' => $this->input->post('couta_mantenimiento'),
					'fecha_registro' => $this->input->post('fecha_registro'),
					'fecha_modificacion' => date("Y-m-d H:i:s"),
					'estado' => $this->input->post('estado'),
					'cuota_mantenimiento' => $this->input->post('cuota_mantenimiento'),
					'calle' => $this->input->post('calle'),
					'numero_exterior' => $this->input->post('numero_exterior'),
					'codigo_postal' => $this->input->post('codigo_postal'),
                );

                $this->Propiedad_model->update_propiedad($id,$params);            
                redirect('propiedad');
            }
            else
            {
                $data['controlador'] = 'propiedad';
                $data['contenido'] = 'propiedad/edit';
                $data['titulo'] = 'Editar Propiedad';
                $this->load->view('templates/template_admin', $data);
            }
        }
        else
            show_error('The propiedad you are trying to edit does not exist.');
    } 

    /*
     * Deleting propiedad
     */
    function remove($id)
    {
        $propiedad = $this->Propiedad_model->get_propiedad($id);

        // check if the propiedad exists before trying to delete it
        if(isset($propiedad['id']))
        {
            $this->Propiedad_model->delete_propiedad($id);
            redirect('propiedad');
        }
        else
            show_error('The propiedad you are trying to delete does not exist.');
    }
    
}
